#!/usr/bin/env python
# this code is an extension of the code of 
# http://nbviewer.ipython.org/gist/harrism/f5707335f40af9463c43 
# Peter Beerli
import numpy as np
from timeit import default_timer as timer
import math
import cmath
import matplotlib
matplotlib.use('PDF')
import matplotlib.pyplot as plt
from matplotlib.backends.backend_pdf import PdfFile
import mandelbrot2cython as mc

from multiprocessing import Pool

# GLOBAL variable
jet_vals = []

if __name__ == '__main__':
  h = 500
  w = 800
  max_iter = 500
  

  jet_vals = mc.create_jetcolorlist(jet_vals,max_iter)
  image = np.empty((w,h,4),np.float32)
  image1 = np.empty((w/4,h,4),np.float32)
  image2 = np.empty((w/4,h,4),np.float32)
  image3 = np.empty((w/4,h,4),np.float32)
  image4 = np.empty((w/4,h,4),np.float32)
  start = timer()
  # seahorse -.743,030, Im(c) = .126,433 diameter  .016,110
  xl,xu,yl,yu = [-0.743030-0.008055,-0.743030+0.008055, 0.126433-0.008055, 0.126433+0.008055]
  # standard
  #xl,xu,yl,yu = [-2.,1.,-1.0,1.0]
  #xl,xu,yl,yu = [-1.5,-0.5,-0.25,0.25]
  #xl,xu,yl,yu = [-1.3,-1.2,-0.15,0.0]
  pool = Pool()
  r1 = pool.apply_async(mc.create_fractal, [xl,xu,yl,yl+(yu-yl)/4, image1, max_iter,jet_vals]) 
  r2 = pool.apply_async(mc.create_fractal, [xl,xu,yl+(yu-yl)/4,yl+(yu-yl)/2, image2, max_iter,jet_vals]) 
  r3 = pool.apply_async(mc.create_fractal, [xl,xu,yl+(yu-yl)/2,yl+3*(yu-yl)/4, image3, max_iter,jet_vals]) 
  r4 = pool.apply_async(mc.create_fractal, [xl,xu,yl+3*(yu-yl)/4,yu, image4, max_iter,jet_vals]) 
  answer1 = r1.get(timeout=100)
  answer2 = r2.get(timeout=100)
  answer3 = r3.get(timeout=100)
  answer4 = r4.get(timeout=100)
  image[:w/4,:] = answer1
  image[w/4:w/2,:] = answer2
  image[w/2:3*w/4,:] = answer3
  image[3*w/4:,:] = answer4
  dt = timer() - start
  print "Mandelbrot created in %f s" % dt
  ii=ax.imshow(image,interpolation='none', extent=[xl,xu,yl,yu],aspect='auto')
  plt.savefig('fig1.pdf', format='pdf')
