from __future__ import division
import time
import math
import multiprocessing
import numpy as np
import sys

record = []

def Pi(q, startnum,stopnum,num_steps):
    step = 1.0/num_steps
    sum = 0
    for i in xrange(startnum,stopnum):
        x= (i+0.5)*step
        sum += 4.0/(1.0+x*x)
    pi = step * sum
    q.put(pi)


if __name__ == '__main__':
    NUM_WORKER = 4
    num_steps = 100000
    if len(sys.argv)==3:
        NUM_WORKER = int(sys.argv[1])
        num_steps = int(sys.argv[2])
    start_time = time.time()
    s = range(0,num_steps+1,int(num_steps/NUM_WORKER))
    q = multiprocessing.Queue()
    p = [multiprocessing.Process(target=Pi, args=(q,s[i],s[i+1],num_steps,)) for i in range(NUM_WORKER)]
    [pi.start() for pi in p]
    r = [q.get() for i in range(NUM_WORKER)]
    [pi.join() for pi in p]
    pi = sum(r)
    end_time = time.time()
    error = np.fabs(np.pi - pi)
    print "Parallel time=", end_time - start_time
    print "Pi           =",pi
    print "Error        =",error
    print "Iterations   =",num_steps

